package ab;

/**
 * Encapsulates address data.
 * 
 * @author ahoefer
 * 
 */
public class Address {

	private String firstname = "";

	private String lastname = "";

	private String eMail = "";

	private String landline = "";

	private String mobile = "";

	private String address1 = "";

	private String address2 = "";

	private String zipCode = "";

	private String city = "";

	private String county = "";

	private Category category = Category.MISC;

	/**
	 * Default constructor.
	 */
	public Address() {

	}

	/**
	 * Copy constructor.
	 * 
	 * @param other
	 *            The address to copy.
	 */
	public Address(final Address other) {
		copyAll(other);
	}

	/**
	 * Copies the content from the other address into this one.
	 * 
	 * @param other
	 *            The address to copy.
	 */
	public void copyAll(final Address other) {
		this.firstname = other.firstname;
		this.lastname = other.lastname;
		this.eMail = other.eMail;
		this.landline = other.landline;
		this.mobile = other.mobile;
		this.address1 = other.address1;
		this.address2 = other.address2;
		this.zipCode = other.zipCode;
		this.city = other.city;
		this.county = other.county;
		this.category = other.category;
	}

	/**
	 * Returns the category.
	 * 
	 * @return The category, default is Category.NONE.
	 */
	public Category getCategory() {
		return category;
	}

	/**
	 * Sets the category.
	 * 
	 * @param category
	 *            the category
	 */
	public void setCategory(Category category) {
		this.category = category;
	}

	/**
	 * Returns the firstname.
	 * 
	 * @return the firstname
	 */
	public String getFirstname() {
		return firstname;
	}

	/**
	 * Sets the firstname.
	 * 
	 * @param firstname
	 *            the firstname
	 */
	public void setFirstname(String firstname) {
		this.firstname = firstname;
	}

	/**
	 * Returns the lastname.
	 * 
	 * @return the lastname
	 */
	public String getLastname() {
		return lastname;
	}

	/**
	 * Sets the lastname.
	 * 
	 * @param lastname
	 *            the lastname
	 */
	public void setLastname(String lastname) {
		this.lastname = lastname;
	}

	/**
	 * Returns the e-mail.
	 * 
	 * @return the e-mail
	 */
	public String getEMail() {
		return eMail;
	}

	/**
	 * Sets the e-mail.
	 * 
	 * @param eMail
	 *            the e-mail
	 */
	public void setEMail(String eMail) {
		this.eMail = eMail;
	}

	/**
	 * Returns the landline number.
	 * 
	 * @return the landline number
	 */
	public String getLandline() {
		return landline;
	}

	/**
	 * Sets the landline number.
	 * 
	 * @param landline
	 *            the landline number
	 */
	public void setLandline(String landline) {
		this.landline = landline;
	}

	/**
	 * Returns the mobile number
	 * 
	 * @return the mobile number
	 */
	public String getMobile() {
		return mobile;
	}

	/**
	 * Sets the mobile number.
	 * 
	 * @param mobile
	 *            the mobile number
	 */
	public void setMobile(String mobile) {
		this.mobile = mobile;
	}

	/**
	 * Returns the address (part 1).
	 * 
	 * @return the address (part 1)
	 */
	public String getAddress1() {
		return address1;
	}

	/**
	 * Sets the address (part 1).
	 * 
	 * @param address1
	 *            the address (part 1)
	 */
	public void setAddress1(String address1) {
		this.address1 = address1;
	}

	/**
	 * Returns the address (part 2).
	 * 
	 * @return the address (part 2).
	 */
	public String getAddress2() {
		return address2;
	}

	/**
	 * Sets the address (part 2).
	 * 
	 * @param address2
	 *            the address (part 2).
	 */
	public void setAddress2(String address2) {
		this.address2 = address2;
	}

	/**
	 * Returns the ZIP Code.
	 * 
	 * @return the ZIP Code
	 */
	public String getZipCode() {
		return zipCode;
	}

	/**
	 * Sets the ZIP Code.
	 * 
	 * @param zipCode
	 *            the ZIP Code
	 */
	public void setZipCode(String zipCode) {
		this.zipCode = zipCode;
	}

	/**
	 * Returns the city.
	 * 
	 * @return the city
	 */
	public String getCity() {
		return city;
	}

	/**
	 * Sets the city.
	 * 
	 * @param city
	 *            the city
	 */
	public void setCity(String city) {
		this.city = city;
	}

	/**
	 * Returns the country.
	 * 
	 * @return the country
	 */
	public String getCounty() {
		return county;
	}

	/**
	 * Sets the country.
	 * 
	 * @param county
	 *            the country
	 */
	public void setCounty(String county) {
		this.county = county;
	}
}
